<template>
    <div id="search">
        <form @submit.prevent="handleSubmit">
            <div class="form-group">
                <div class="input-group">
                    <input type="text" class="form-control" id="search-input" placeholder="Search" autocomplete="off">
                    <div class="input-group-append">
                        <!--<span class="input-group-text">
                            <span class="fas fa-search"/>
                        </span>-->
                        <button type="submit" class="input-group-text">
                            <label for="search-input" class="p-0 m-0">
                                <span class="fas fa-search"/>
                            </label>
                        </button>
                    </div>
                </div>
            </div>
            <div class="card">
                <div @click="toggleAdvanced" class="card-header" :class="{'bg-dark text-white': advanced}">
                    <span class="fas fa-sliders-h mr-2"/> Advanced options
                </div>
                <div v-if="advanced" class="card-body bg-light">
                    <h4 class="font-weight-normal form-check">
                        <label class="form-check-label">
                            <input v-model="tables.people" @change="noJobs" type="checkbox" class="form-check-input">
                            People
                        </label>
                    </h4>
                    <h5 class="font-weight-normal">Jobs</h5>
                    <div class="form-group form-inline" id="jobs">
                        <div class="form-check mr-3" v-for="(job, index) in jobs" :key="index">
                            <label class="form-check-label">
                                <input v-model="job.value" @change="activatePeople" type="checkbox"
                                       class="form-check-input"
                                >
                                {{ job.name }}
                            </label>
                        </div>
                        <div class="form-check mr-3">
                            <label class="form-check-label">
                                <input v-model="no.jobs.value" @change="activatePeople" type="checkbox"
                                       class="form-check-input"> {{ no.jobs.name }}
                            </label>
                        </div>
                    </div>
                    <hr>
                    <h4 class="font-weight-normal form-check">
                        <label class="form-check-label">
                            <input v-model="tables.entertainment" @change="noEntertainment" type="checkbox"
                                   class="form-check-input"
                            >
                            Entertainment
                        </label>
                    </h4>
                    <h5 class="font-weight-normal">Types</h5>
                    <div class="form-group form-inline">
                        <div class="form-check mr-3" v-for="(type, index) in types" :key="index">
                            <label class="form-check-label">
                                <input v-model="type.value" @change="activateEntertainment" type="checkbox"
                                       class="form-check-input"> {{ type.name }}
                            </label>
                        </div>
                    </div>
                    <h5 class="font-weight-normal">Genres</h5>
                    <div class="form-group form-inline">
                        <div class="form-check mr-3" v-for="(genre, index) in genres" :key="index">
                            <label class="form-check-label">
                                <input v-model="genre.value" @change="activateEntertainment" type="checkbox"
                                       class="form-check-input"> {{ genre.name }}
                            </label>
                        </div>
                        <div class="form-check mr-3">
                            <label class="form-check-label">
                                <input v-model="no.genres.value" @change="activateEntertainment" type="checkbox"
                                       class="form-check-input"> {{ no.genres.name }}
                            </label>
                        </div>
                    </div>
                    <div class="row" @keyup="activateEntertainment">
                        <div class="col-md">
                            <h5 class="font-weight-normal">Budget</h5>
                            <div class="form-group">
                                <label>Min</label>
                                <div class="input-group">
                                    <div class="input-group-append">
                                        <span class="input-group-text">
                                            <span class="fas fa-dollar-sign"/>
                                        </span>
                                    </div>
                                    <input v-model="budget.min" type="number" class="form-control" min="0"
                                           max="500000000"
                                           :placeholder="placeholders.dollars"
                                    >
                                </div>
                            </div>
                            <div class="form-group mb-md-0">
                                <label>Max</label>
                                <div class="input-group">
                                    <div class="input-group-append">
                                        <span class="input-group-text">
                                            <span class="fas fa-dollar-sign"/>
                                        </span>
                                    </div>
                                    <input v-model="budget.max" type="number" class="form-control" min="0"
                                           max="500000000"
                                           :placeholder="placeholders.dollars"
                                    >
                                </div>
                            </div>
                        </div>
                        <div class="col-md">
                            <h5 class="font-weight-normal">Gross</h5>
                            <div class="form-group">
                                <label>Min</label>
                                <div class="input-group">
                                    <div class="input-group-append">
                                        <span class="input-group-text">
                                            <span class="fas fa-dollar-sign"/>
                                        </span>
                                    </div>
                                    <input v-model="gross.min" type="number" class="form-control" min="0"
                                           max="5000000000"
                                           :placeholder="placeholders.dollars"
                                    >
                                </div>
                            </div>
                            <div class="form-group mb-md-0">
                                <label>Max</label>
                                <div class="input-group">
                                    <div class="input-group-append">
                                        <span class="input-group-text">
                                            <span class="fas fa-dollar-sign"/>
                                        </span>
                                    </div>
                                    <input v-model="gross.max" type="number" class="form-control" min="0"
                                           max="5000000000"
                                           :placeholder="placeholders.dollars"
                                    >
                                </div>
                            </div>
                        </div>
                        <div class="col-md">
                            <h5 class="font-weight-normal">Released</h5>
                            <div class="row">
                                <div class="col">
                                    <div class="form-group mb-0">
                                        <label>Min</label>
                                        <input v-model="released.min" type="number" class="form-control" min="1900"
                                               max="2099"
                                               :placeholder="placeholders.year"
                                        >
                                    </div>
                                </div>
                                <div class="col">
                                    <div class="form-group mb-0">
                                        <label>Max</label>
                                        <input v-model="released.max" type="number" class="form-control" min="1900"
                                               max="2099"
                                               :placeholder="placeholders.year"
                                        >
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div v-if="results.people.length > 0 || results.entertainment.length > 0" class="row mt-4">
                <div v-if="results.people.length > 0" class="col-md">
                    <h4 class="font-weight-normal">People</h4>
                    <list :matches="results.people" table="people" :link="true"/>
                </div>
                <div v-if="results.entertainment.length > 0" class="col-md">
                    <h4 class="font-weight-normal">Entertainment</h4>
                    <list :matches="results.entertainment" table="entertainment" :link="true"/>
                </div>
            </div>
            <p v-else-if="errors.no_table_selected" class="bg-danger text-white mt-4 px-2">
                People and/or entertainment needs to be selected.
            </p>
            <p v-else-if="errors.no_job_selected" class="bg-danger text-white mt-4 px-2">
                If you want to search for people, at least one job needs to be selected.
            </p>
            <p v-else-if="errors.no_genre_selected" class="bg-danger text-white mt-4 px-2">
                If you want to search for entertainment, at least one genre needs to be selected.
            </p>
            <p v-else-if="errors.no_type_selected" class="bg-danger text-white mt-4 px-2">
                If you want to search for entertainment, at least one type needs to be selected.
            </p>
        </form>
    </div>
</template>

<script>
    import List from "@/components/List";

    export default {
        name: 'search',
        components: {
            List
        },
        data() {
            return {
                advanced: false,
                genres: [],
                no: {
                    genres: {
                        name: 'Include titles with no genres',
                        value: true,
                    },
                    jobs: {
                        name: 'Include people with no jobs',
                        value: true,
                    },
                },
                jobs: [],
                types: [],
                released: {
                    min: '',
                    max: '',
                },
                budget: {
                    min: '',
                    max: '',
                },
                gross: {
                    min: '',
                    max: '',
                },
                tables: {
                    people: true,
                    entertainment: true,
                },
                placeholders: {
                    dollars: 'Enter a number',
                    year: 'Year',
                },
                results: {
                    people: [],
                    entertainment: [],
                },
                errors: {
                    no_table_selected: false,
                    no_job_selected: false,
                    no_genre_selected: false,
                    no_type_selected: false,
                },
            }
        },
        mounted() {
            this.getGenres();
            this.getJobs();
            this.getTypes();
        },
        methods: {
            async toggleAdvanced() {
                this.advanced = !this.advanced;
                if (this.advanced) {
                    await this.$forceUpdate();
                    document.querySelectorAll('form input').forEach(el => {
                        el.addEventListener('change', () => {
                            this.errors.no_job_selected = false;
                            this.errors.no_type_selected = false;
                            this.errors.no_genre_selected = false;
                            this.errors.no_table_selected = false;
                        })
                    })
                }
            },
            async getGenres() {
                const response = await fetch(`http://localhost:8081/api/genres`);
                const data = await response.json();
                for (let genre of data) {
                    genre.value = true;
                    this.genres.push(genre);
                }
            },
            async getJobs() {
                const response = await fetch(`http://localhost:8081/api/jobs`);
                const data = await response.json();
                for (let job of data) {
                    job.value = true;
                    this.jobs.push(job);
                }
            },
            async getTypes() {
                const response = await fetch(`http://localhost:8081/api/types`);
                const data = await response.json();
                for (let type of data) {
                    type.value = true;
                    this.types.push(type);
                }
            },
            noJobs() {
                for (let i = 0; i < Object.values(this.jobs).length; i++) {
                    this.jobs[i].value = this.tables.people
                }
                this.no.jobs.value = this.tables.people
            },
            activatePeople() {
                this.tables.people = true
            },
            noEntertainment() {
                for (let i = 0; i < Object.values(this.types).length; i++) {
                    this.types[i].value = this.tables.entertainment
                }
                for (let i = 0; i < Object.values(this.genres).length; i++) {
                    this.genres[i].value = this.tables.entertainment
                }
                if (!this.tables.entertainment) {
                    this.released.min = '';
                    this.released.max = '';
                    this.budget.min = '';
                    this.budget.max = '';
                    this.gross.min = '';
                    this.gross.max = '';
                }
                this.no.genres.value = this.tables.entertainment
            },
            activateEntertainment() {
                this.tables.entertainment = true
            },
            async handleSubmit() {
                this.advanced = false;
                this.results.people.splice(0, this.results.people.length);
                this.results.entertainment.splice(0, this.results.entertainment.length);
                if (!this.tables.people && !this.tables.entertainment) {
                    this.errors.no_table_selected = true;
                    return;
                }
                if (this.tables.people) {
                    let jobs = '';
                    for (let i = 0; i < this.jobs.length; i++) {
                        const job = this.jobs[i];
                        if (job.value) {
                            if (jobs.length > 0) {
                                jobs += ',';
                            }
                            jobs += job.id;
                        }
                    }
                    if (jobs.length === 0  && !this.no.jobs) {
                        this.errors.no_job_selected = true;
                        return;
                    }
                    let query = `?jobs=${jobs}`, value;
                    value = document.getElementById('search-input').value;
                    query += value ? `&like=${value}` : '';
                    value = this.no.jobs.value;
                    query += value ? `&no_jobs=${value}` : '';
                    const response = await fetch(`http://localhost:8081/api/people${query}`);
                    this.results.people = await response.json();
                }
                if (this.tables.entertainment) {
                    let genres = '';
                    for (let i = 0; i < this.genres.length; i++) {
                        const genre = this.genres[i];
                        if (genre.value) {
                            if (genres.length > 0) {
                                genres += ',';
                            }
                            genres += genre.id;
                        }
                    }
                    if (genres.length === 0 && !this.no.genres) {
                        this.errors.no_genre_selected = true;
                        return;
                    }
                    let types = '';
                    for (let i = 0; i < this.types.length; i++) {
                        const type = this.types[i];
                        if (type.value) {
                            if (types.length > 0) {
                                types += ',';
                            }
                            types += type.id;
                        }
                    }
                    if (types.length === 0) {
                        this.errors.no_type_selected = true;
                        return;
                    }
                    let query = `?types=${types}&genres=${genres}`, value;
                    value = document.getElementById('search-input').value;
                    query += value ? `&like=${value}` : '';
                    value = this.no.genres.value;
                    query += value ? `&no_genres=${value}` : '';
                    value = this.released.min;
                    query += value ? `&earliest=${value}` : '';
                    value = this.released.max;
                    query += value ? `&latest=${value}` : '';
                    value = this.budget.min;
                    query += value ? `&budget_at_least=${value}` : '';
                    value = this.budget.max;
                    query += value ? `&budget_at_most=${value}` : '';
                    value = this.gross.min;
                    query += value ? `&gross_at_least=${value}` : '';
                    value = this.gross.max;
                    query += value ? `&gross_at_most=${value}` : '';
                    const response = await fetch(`http://localhost:8081/api/entertainment${query}`);
                    this.results.entertainment = await response.json();
                }
            },
            resetErrors() {
                this.errors.no_job_selected = false;
                this.errors.no_type_selected = false;
                this.errors.no_genre_selected = false;
                this.errors.no_table_selected = false;
            }
        }
    }
</script>

<style scoped>
    button *, div.card-header {
        cursor: pointer;
    }

    h4 input.form-check-input {
        height: 1.5rem;
    }
</style>